
/*
 * LpInv: Prototype Program Analyzer for Linear Systems using 
 *        Linear Programming. 
 * Author: Sriram Sankanarayanan <srirams@theory.stanford.edu> 
 * Copyright (c) 2005 Sriram Sankaranarayanan.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *        
 */



#include "myassertions.h"
#include <stdio.h>
#include "ResourceMonitor.h"


#define KBS_PER_PAGE 4

void ResourceMonitor::take_a_reading(){

   FILE * in = fopen( "/proc/self/statm", "r");
   
   INVARIANT( in, " Error opening /proc/self/statm -- unable to monitor resources ");

   long rss_usage;
   
   /* now read in the process statistics */
   /*
   char name[256];
   int dint;
   char dchar;
   long dlong;
   

   // first read in the pid and the cmd line
   
   fscanf(in, "%d", &dint); // the pid
   fscanf(in, "%s", name); // the proc name
   fscanf(in, "%c", &dchar); // the proc state

   fscanf(in, "%d", &dint); // the ppid
   fscanf(in, "%d", &dint); // the pgrp
   fscanf(in, "%d", &dint); // the session
   fscanf(in, "%d", &dint); // the tty being used
   fscanf(in, "%d", &dint); // the tpgid  being used

   fscanf(in, "%d", &dint); // the flags being used
   fscanf(in, "%lu", &dlong); // the # of minor page faults
   fscanf(in, "%lu", &dlong); // the # of childrens minor page faults
   fscanf(in, "%lu", &dlong); // the major page faults
   fscanf(in, "%lu", &dlong);// also of the children

   fscanf(in, "%lu", &dlong);// the user time
   fscanf(in, "%lu", &dlong);// the system time
   
   fscanf(in, "%ld", &dlong);// the user time children
   fscanf(in, "%ld", &dlong);// the system time children

   
   fscanf(in, "%ld", &dlong);// the priority
   fscanf(in, "%ld", &dlong);// the nice lebel

   fscanf(in, "%ld", &dlong);// a dummy 0

   
   fscanf(in, "%ld", &dlong);// itrealvalue
   fscanf(in, "%ld", &dlong);// starttime

   fscanf(in, "%lu", &dlong);//vemmory size
   fscanf(in, "%lu", &dlong);//vemmory size

  
   */
   fscanf(in, "%lu", &rss_usage);// what i am after
  
  
   // make the reading
   
   _vreads.push_back(rss_usage * KBS_PER_PAGE );
   
   
   fclose(in);
}


