
/*
 * LpInv: Prototype Program Analyzer for Linear Systems using 
 *        Linear Programming. 
 * Author: Sriram Sankanarayanan <srirams@theory.stanford.edu> 
 * Copyright (c) 2005 Sriram Sankaranarayanan.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *        
 */


#ifndef D__CARS_DRIVER__H_
#define D__CARS_DRIVER_H_

/*
 * Create the transition systems corresponding to the n-cars
 * example automatically 
 */

#include <vector>
#include <string>
#include <ppl.hh>
#include "parse_globals.h"
#include "TrSys.h"


using namespace std;
using namespace Parma_Polyhedra_Library;

typedef struct var_addr_struct{
   int * x;
   int * v;
   int * a;
   int * r;
   int t;
   int ac;
   int br;

} var_addrs;


extern var_addrs vaddr;

// to access varibles easily

Variable v_x(int i);
Variable v_v(int i);
Variable v_a(int i);
Variable v_r(int i);
Variable v_t();
Variable v_ac();
Variable v_br();

void form_var_info();

void form_invariant_polyhedron(C_Polyhedron & where);
void form_initial_polyhedron(C_Polyhedron & where);

bool increment_pattern(vector<bool> & pattern);

void add_time_elapse_transition(C_Polyhedron & inv, vector<bool> const & pattern);

void construct_transition_for_car(C_Polyhedron & inv, int i);

void form_system();


#endif
