%{
/* A quick fix solution to use the existing interface and
 * parse some other types of file formats
 */ 

#include <iostream>
#include <vector>
#include <string>
#include <ppl.hh>
#include "parse_globals.h"
#include "var-info.h"
#include "Rational.h"
#include "TrSys.h"
#include "delzanno.tab.h"

%}


delim  [ \t]
line [\n]
whitespace {delim}+
digit [0-9]
letter [a-zA-Z_]
ident  {letter}({letter}|{digit})*
number {digit}+

%%

"var" {return VAR;}
"nat" {return NAT;}
"problem" {return PROBLEM;}
"initial" {return INITS;}
"final" {return FINAL;}
"transition" {return TRANSITION;}
"template" {return TEMPLATE;}
"Template" {return TEMPLATE;}
";" {return ';';}
"(" {return '(';}
")" {return ')';}
"->" { return LEADSTO;}
"&" {return '&';}
"," {return ',';}
":" {return ':';}
"+" {return '+';}
"*" {return '*';}
"$" {return '$';}
"-" {return '-';}
"=" {return EQ;}
">=" {return GEQ;}
"<=" {return LEQ;}
":=" {return ASSIGN;}

{number} {yylval.integer=atoi((char *) yytext); return INT;}
{ident} {
          yylval.identifier = new string(yytext);
          return IDENT;
         }
{whitespace} 
{line} {linenum++; }


"\%" {  /* Comment line */
   int c;
   c=yyinput();
   while (c!='\n' &&  c!=EOF){
     c=yyinput();
   }
 }

.  {printf("Unknown Character in line %d : %s -- Ignored\n", linenum,yytext);}

%%


int yywrap(){
return 1;
}
