%{
#include <iostream>
#include <vector>
#include <string>
#include <ppl.hh>
#include "parse_globals.h"
#include "var-info.h"
#include "Rational.h"
#include "TrSys.h"
#include "duchess.tab.h"

%}


delim  [ \t]
line [\n]
whitespace {delim}+
digit [0-9]
letter [a-zA-Z_]
ident  {letter}({letter}|{digit})*
number {digit}+

%%

transition {return TRS;}
Transition {return TRS;}

Location {return LOC;}
location {return LOC;}

Template {return TEMPLATE;}
template {return TEMPLATE;}

Guard {return GRD;}
guard {return GRD;}

with {return WITH;}
With {return WITH;}


var {return VARIABLE;}
Var {return VARIABLE;}

True {return TRUE;}
true {return TRUE;}

False {return FALSE;}
false {return FALSE;}

And {return AND;}
AND {return AND;}
and {return AND;}

"/\\" {return AND;}

"+" {return '+';}
"*" {return '*';}

"-" {return '-';}
">" {return  GE ;}
"<" {return  LE;}
"=" {return EQ;}
">=" {return GEQ;}
"<=" {return LEQ;}
":=" {return ASSIGN;}
"->" {return LEADSTO;}
"<-" {return ASSIGN;}
"," {return ',';}
";" {return ';';}
":" {return ':';}
"(" {return '(';}
")" {return ')';}
"{" {return '{';}
"}" {return '}';}
"[" {return '[';}
"]" {return ']';}

"$" {return '$';}

end {return END;}

{number} {yylval.integer=atoi((char *) yytext); return INT;}
{ident} {
          yylval.identifier = new string(yytext);
          return IDENT;
         }
{whitespace} 
{line} {linenum++; }

"#" {  /* Comment line */
   int c;
   c=yyinput();
   while (c!='\n' &&  c!=EOF){
     c=yyinput();
   }
if (c=='\n')
  linenum++;
}

.  {printf("Unknown Character in line %d : %s -- Ignored\n", linenum,yytext);}

%%


int yywrap(){
return 1;
}
